<?php
/*
 *   +----------------------------------+
 *    Nom :   Table des matieres
 *   +----------------------------------+
 *    Date : aout 2004
 *    Auteur :  Mortimer Porte mortimer.pa@free.fr
 *   +-------------------------------------+
 *    Fonctions de ce filtre :
 *     affiche une table des matires et gnre automatiquement la numrotation des titres.
 *   +-------------------------------------+
 *
 * Pour toute suggestion, remarque, proposition d'ajout
 * reportez-vous au forum de l'article :
 * http://www.spip_contrib.net/article.php3?id_article=627
*/
function table_des_matieres($texte) {
  global $debut_intertitre, $fin_intertitre;

   // dfinition de la balise pour les titres des sections %num% sera remplac
  // par la profondeur de la section
  $css_debut_intertitre = "\n<h3 class=\"spiphead%num%\">";
  $css_fin_intertitre = "</h3>\n";

  // on cherche les noms de section commenant par des *
  $count = preg_match_all("(($debut_intertitre(\\*+)(.*?)(<(.*?)>)?$fin_intertitre))",$texte,$matches);
  $table = '';
  //initialisation du compteur
  $cnt[0] = 0;
  //initialisation du code de la table des matires
  $table = "\n<ul id='tablematiere'>\n";
  $lastlevel = 1;
  $cite[''] = '';

  //pour chaque titre trouv
  for ($j=0; $j< $count; $j++) {
	$level = $matches[2][$j];
	$titre = $matches[3][$j];
	$ref = $matches[5][$j];
	if(strlen($level) == 1) {
           //on est au niveau de base
          //on rinitialise les compteurs
	  for ($i=1; $i < count($cnt); $i++) {
		$cnt[$i] = 0;
	  }
          //on gnre le titre et le numros
	  $numeros = ++$cnt[0];
	  //$titre = $numeros.' '.$titre;
	} else {
           //on est  un niveau plus profond
          // on construit le numros
	  $numeros = $cnt[0].'.';
	  for ($i=1; $i < strlen($level)-1; $i++) {
		$numeros .= $cnt[$i].".";
	  }
	  $numeros = $numeros.(++$cnt[$i]);
          //on gnre le titre
	  //$titre = $numeros.' '.$titre;

	}

        //gestion de la liste dans la table
	if($lastlevel < strlen($level)) {
          //on ouvre une sous liste
	  $table .= "<ul>\n";
	}
	if($lastlevel > strlen($level)) {
          //on doit fermer les derniers niveaux
	  for ($i=0; $i < ($lastlevel - strlen($level)); $i++) {
		$table .= "</li>\n</ul>";
	  }
	}
	if($lastlevel >= strlen($level)) {
          //on doit fermer l'item prcdent
	  if($cnt[0] > 1 || strlen($level) > 1) {
		$table .= "</li>\n";
	  }
	}
       //on se rappelle du raccourcis
	$cite[$ref] = $numeros;
	$table .= "<li><A href='#$numeros'>$titre</A>";

       //on mmorise le niveau de ce titre
	$lastlevel = strlen($level);

        //on gnre la balise avec le bon style pour le niveau
	$mdebut_intertitre = str_replace('%num%',$lastlevel,$css_debut_intertitre);
	$mfin_intertitre = str_replace('%num%',$lastlevel,$css_fin_intertitre);
        //on remplace le titre dans le texte
	$texte = str_replace($matches[0][$j],"$mdebut_intertitre<A name='$numeros'></A>$titre$mfin_intertitre",$texte);
  }
  //on fini la table
  for ($i=0; $i < $lastlevel; $i++) {
	$table .= "</li>\n</ul>";
  }
  //on remplace les raccourcis par les numros des sections.
  foreach ($cite as $ref => $num) {
	$texte = str_replace("<$ref>","<A href='#$num'>$num</A>",$texte);
  }
  //on place la table des matires dans le texte
  $texte = str_replace('#TABLEMATIERES',$table,$texte);
  return $texte;
}

function apres_propre($texte) {
 $new_texte = table_des_matieres($texte);
 return $new_texte;
}

/*
 *   +----------------------------------+
 *    Nom du Filtre : decouper_en_page
 *   +----------------------------------+
 *    Date : mardi 28 janvier 2003
 *    Auteur :  "gpl"  : gpl@macplus.org
 *   +-------------------------------------+
 *    Fonctions de ce filtre :
 *     Il sert a prsenter un article sur plusieurs pages
 *   +-------------------------------------+
 *
 * Pour toute suggestion, remarque, proposition d'ajout
 * reportez-vous au forum de l'article :
 * http://www.uzine.net/spip_contrib/article.php3?id_article=62
*/


function decouper_en_page($texte) {
        global $artsuite, $var_recherche;

        if (empty($artsuite)) $artsuite = 0;

        $page = split('-NP-', $texte);

        $num_pages = count($page);

        // Si une seule page ou numro illgal, alors retourner tout le texte.
        // Cas spcial : si var_recherche positionn, tout renvoyer pour permettre  la surbrillance
				// de fonctionner correctement.
        if ($num_pages == 1 || !empty($var_recherche) || $artsuite < 0 || $artsuite > $num_pages) {
                return $texte;
        }

        $p_prec = $artsuite - 1;
        $p_suiv = $artsuite + 1;
        $uri_art = generer_url_article($GLOBALS['id_article']);
        $uri_art .= strpos($uri_art, '?') ? '&' : '?';

        switch (TRUE) {
                case ($artsuite == 0):
                        $precedent = "";
                        $suivant = "<A HREF='" . $uri_art . "artsuite=" . $p_suiv . "'>&gt;&gt;</A>";
                        break;
                case ($artsuite == ($num_pages-1)):
                        $precedent = "<A HREF='" . $uri_art . "artsuite=" . $p_prec . "'>&lt;&lt;</A>";
                        $suivant = "";
                        break;
                default:
                        $precedent = "<A HREF='" . $uri_art . "artsuite=" . $p_prec . "'>&lt;&lt;</A>";
                        $suivant = "<A HREF='" . $uri_art . "artsuite=" . $p_suiv . "'>&gt;&gt;</A>";
                        break;
        }

        for ($i = 0; $i < $num_pages; $i++) {
                $j = $i;
                if ($i == $artsuite) {
                        $milieu .= " <B>" . ++$j . "</B> ";
                } else {
                        $milieu .= " <A HREF='" . $uri_art . "artsuite=$i'>" . ++$j . "</A> ";
                }
        }

        // Ici, on peut personnaliser la prsentation
        $resultat = "<P><DIV CLASS='pagination'>$precedent $milieu $suivant</DIV></P>";
        $resultat .= $page[$artsuite];
        $resultat .= "<P CLASS='pagination'><DIV CLASS='pagination'>$precedent $milieu $suivant</DIV></P>";
        return $resultat;
}
// FIN du Filtre decouper_en_page


/*
 *   +----------------------------------+
 *    Nom du Filtre : meta_keywords
 *   +----------------------------------+
 *    Date : 3 mai 2005
 *    Auteur :  Georges Cubas
 *    contact : http://www.sourisverte.net/auteur.php3?id_auteur=1
 *   +-------------------------------------+
 *    Fonctions de ce filtre :
 *   rend le texte entr en paramtre compatible avec le metatag "keywords"
 *    - ne repetes pas les mots,
 *    - classe les mot par nombre d'ocurence dcroissant
 *    - ne prend pas en compte les mot de moins de 4 lettres : le la les ...
 *   +-------------------------------------+
 * reportez-vous au forum de l'article :
 * http://www.spip-contrib.net/article.php3?id_article=945
 */

//dbut filtre meta_keywords

function meta_keywords($texte) {
	// met tous les mots (suite de carateres a-z_) de plus de trois lettres ({4,}) dans $tableau[0]
	if (preg_match_all("/[a-z_]{4,}/",strtolower($texte), $tableau) > 0)
	{
		$tableau = array_count_values($tableau[0]); // tri les mots par leurs frquences
		arsort($tableau);
		
		$result = "";
		foreach($tableau as $key=>$value) // cre la liste de mots cls
			$result .= "$key ";
		return trim($result); // renvoit la liste sans l'espace  la fin
	}
	return ""; // si il n'y a pas de mot de plus de 3 lettres renvoit rien
}
//fin filtre meta_keywords


?>